// A faire : implementation potentiomètre 

// Sortie PWM
int To_Moteur_PWM = 9; 

// Entree potentiometre
const int Potent_pin = A0; 
int val_Pot = 0;      
float val_reel = 0.0;      
float Seuil_HC=0.0;
int Etat_seche = 0; 

// Variables pour HC-SR04
const int Echo_in_pin = 2; 
const int Trig_out_pin = 3;
float Dist_mm=0.0;
long HC_val=0; 

// Vitesse du son (mm/us) 
const double Speed_sound = 340.0e-3;

   
void setup()
{
	// Seria port 
	Serial.begin(9600);
		
	// Initialisation HC-SR04
	pinMode(Trig_out_pin, OUTPUT);
	pinMode(Echo_in_pin, INPUT);
	digitalWrite(Trig_out_pin, LOW);
}
void loop() {
        
	// declanchement mesure avec l'envoie d'une impulsion de 10µs
	digitalWrite(Trig_out_pin, HIGH);
	delayMicroseconds(10);
	digitalWrite(Trig_out_pin, LOW);
	
	// Lecture du temps aller/retour de l'onde 
	HC_val = pulseIn(Echo_in_pin, HIGH, 30000);
        
        // Calcul de distance d(mm), V=d/t==> v*t 
        // Le coefficnet 2 pour la distance aller
	Dist_mm = (HC_val/2.0) * Speed_sound; 
	
        //Generation PWM & Controle de la sensibilité du capteur 
        Seuil_HC=GetSeuil(Dist_mm);
        if ((Dist_mm < Seuil_HC) && (Dist_mm > 10.0))
	{
		analogWrite(To_Moteur_PWM, 255);
                Etat_seche=1;
	}
	else 
	{
		analogWrite(To_Moteur_PWM, 0);
                Etat_seche=0;
	}

        // Afficchage de la ditance d(mm/m)
	Serial.print("\n Distance(mm):");
	Serial.print(Dist_mm);
	
        //Seuil
	Serial.print("\n Seuil(mm):");
	Serial.print(Seuil_HC);

        //Etat seche
	Serial.print("\n Etat seche:");
	Serial.print(Etat_seche);
        Serial.print("\n");
        
        // Délai
	delay(1000);
}
float GetSeuil(float dist_ultrason)
{
	float seuil=0; 
	int val_Pot=0; 
	
	if (dist_ultrason > 256.0)  // 256 mm 
	{
		seuil=256.0; 
	}
	else
	{
		//Lecture Poto
		val_Pot = analogRead(Potent_pin);
		seuil=float(val_Pot)/4.0;
	}
	return seuil;
}
